#include <bits/stdc++.h>
//#define int long long
using namespace std;

void sw(int *x, int *y){
    int t=*x;
    *x=*y;
    *y=t;

    }


signed main()
{
    int n, q;
    cin>>n>>q;
    int a[n];
    for(int  i=0; i<n; i++)
        cin>>a[i];
    int l, r;

    for(int w=0; w<q; w++){
       cin>>l>>r;

        int f[r-l+1];
        for(int i=l-1; i<r; i++)
            f[i-l+1]=a[i];


        for(int i=0; i<r-l+1; i++)
            for(int j=i+1; j<r; j++)
                if(f[i]>f[j])
                    sw(&f[i], &f[j]);

        int s=0;
        if(f[0]==f[1])
            s=2;

        for(int i=1; i<r-l; i++){

            if(f[i]==f[i+1]){
                if(s>0)
                    s++;
                else
                    s=2;
            }
            else
                s=0;
        }
        cout<<s<<endl;
        }





    return 0;
}